From e5480d9279b5c911e030470da61c6f25070be7fa Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Wed, 26 Jan 2022 16:24:28 +0100
Subject: [PATCH] templates: always mark required fields (#41123)

---
 src/authentic2/templates/authentic2/change_email.html           | 2 +-
 src/authentic2/templates/authentic2/login_password_form.html    | 2 +-
 .../templates/authentic2/login_password_registration_form.html  | 2 +-
 src/authentic2/templates/registration/password_change_form.html | 2 +-
 .../templates/registration/password_reset_confirm.html          | 2 +-
 src/authentic2/templates/registration/password_reset_form.html  | 2 +-
 .../templates/registration/registration_completion_form.html    | 2 +-
 7 files changed, 7 insertions(+), 7 deletions(-)

diff --git a/src/authentic2/templates/authentic2/change_email.html b/src/authentic2/templates/authentic2/change_email.html
index baa84afe..5fd0f4d6 100644
--- a/src/authentic2/templates/authentic2/change_email.html
+++ b/src/authentic2/templates/authentic2/change_email.html
@@ -14,7 +14,7 @@
 {% block content %}
   <p>{% blocktrans with email=user.email %}Your current email is {{ email }}.
   An email will be sent to validate the new one.{% endblocktrans %}</p>
-  <form method="post" class="pk-mark-optional-fields">
+  <form method="post">
     {% csrf_token %}
     {{ form|with_template }}
     <button class="submit-button">{% trans "Validate" %}</button>
diff --git a/src/authentic2/templates/authentic2/login_password_form.html b/src/authentic2/templates/authentic2/login_password_form.html
index 580a8262..67f6164a 100644
--- a/src/authentic2/templates/authentic2/login_password_form.html
+++ b/src/authentic2/templates/authentic2/login_password_form.html
@@ -4,7 +4,7 @@
 
 {% block form %}
 <div>
-<form method="post" class="pk-mark-optional-fields">
+<form method="post">
 {% csrf_token %}
 {{ form|with_template }}
 {% block buttons %}
diff --git a/src/authentic2/templates/authentic2/login_password_registration_form.html b/src/authentic2/templates/authentic2/login_password_registration_form.html
index e7384af5..31a4c6e0 100644
--- a/src/authentic2/templates/authentic2/login_password_registration_form.html
+++ b/src/authentic2/templates/authentic2/login_password_registration_form.html
@@ -1,7 +1,7 @@
 {% load i18n gadjo %}
 
 {% block registration %}
-<form enctype="multipart/form-data" method="post" class="pk-mark-optional-fields">
+<form enctype="multipart/form-data" method="post">
   {% csrf_token %}
   {{ form|with_template }}
   <button class="submit-button">{% trans 'Submit' %}</button>
diff --git a/src/authentic2/templates/registration/password_change_form.html b/src/authentic2/templates/registration/password_change_form.html
index a38dea38..adef66c5 100644
--- a/src/authentic2/templates/registration/password_change_form.html
+++ b/src/authentic2/templates/registration/password_change_form.html
@@ -12,7 +12,7 @@
 {% endblock %}
 
 {% block content %}
-  <form method="post" action="." class="pk-mark-optional-fields">
+  <form method="post" action=".">
     {% if user.has_usable_password %}
     <p>{% blocktrans %}To change your password you must provide your current password, then provide
     the new password and confirm it.
diff --git a/src/authentic2/templates/registration/password_reset_confirm.html b/src/authentic2/templates/registration/password_reset_confirm.html
index bcc1dff7..20ff9cb4 100644
--- a/src/authentic2/templates/registration/password_reset_confirm.html
+++ b/src/authentic2/templates/registration/password_reset_confirm.html
@@ -9,7 +9,7 @@
 
 {% if validlink %}
 
-<form method="post" class="pk-mark-optional-fields">
+<form method="post">
   {% csrf_token %}
   {{ form|with_template }}
 
diff --git a/src/authentic2/templates/registration/password_reset_form.html b/src/authentic2/templates/registration/password_reset_form.html
index dd9d06da..a262acba 100644
--- a/src/authentic2/templates/registration/password_reset_form.html
+++ b/src/authentic2/templates/registration/password_reset_form.html
@@ -9,7 +9,7 @@
 
 <h2>{% trans "Resetting password" %}</h2>
 
-<form method="post" class="pk-mark-optional-fields">
+<form method="post">
   {% csrf_token %}
   {{ form|with_template }}
 
diff --git a/src/authentic2/templates/registration/registration_completion_form.html b/src/authentic2/templates/registration/registration_completion_form.html
index ef916c97..c831bfa2 100644
--- a/src/authentic2/templates/registration/registration_completion_form.html
+++ b/src/authentic2/templates/registration/registration_completion_form.html
@@ -10,7 +10,7 @@
       <h2>{% trans "Registration" %}</h2>
       <p>{% trans "Please fill the form to complete your registration" %}</p>
       {% endblock %}
-      <form method="post" class="a2-registration-completion-form pk-mark-optional-fields">
+      <form method="post" class="a2-registration-completion-form">
         {% block registration-completion-form-top %}{% endblock %}
         {% csrf_token %}
         {{ form|with_template }}
-- 
2.34.1